//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use super::sea_orm_active_enums::UpstreamType;
use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "Service")]
pub struct Model {
    #[sea_orm(primary_key, auto_increment = false)]
    pub id: Uuid,
    #[sea_orm(column_name = "ownerName", column_type = "Text")]
    pub owner_name: String,
    pub r#type: UpstreamType,
    #[sea_orm(column_type = "Text")]
    pub upstream: String,
    #[sea_orm(column_name = "tcpPorts")]
    pub tcp_ports: Option<Vec<i32>>,
    #[sea_orm(column_name = "udpPorts")]
    pub udp_ports: Option<Vec<i32>>,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(has_many = "super::route::Entity")]
    Route,
    #[sea_orm(has_many = "super::tcp_proxy::Entity")]
    TcpProxy,
    #[sea_orm(
        belongs_to = "super::user::Entity",
        from = "Column::OwnerName",
        to = "super::user::Column::Username",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    User,
}

impl Related<super::route::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Route.def()
    }
}

impl Related<super::tcp_proxy::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::TcpProxy.def()
    }
}

impl Related<super::user::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::User.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
